Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# Geom Class Reference

A container for geometry primitives. More...

Inheritance diagram for Geom:

List of all members.

## Public Member Functions
| Geom (GeomVertexData const data)
| addPrimitive (GeomPrimitive const primitive)
| Adds a new GeomPrimitive structure to the Geom object.
bool | checkValid ()
| Verifies that the all of the primitives within the geom reference vertices that actually exist within the geom's GeomVertexData.
bool | checkValid (GeomVertexData const vertex_data)
| Verifies that the all of the primitives within the geom reference vertices that actually exist within the indicated GeomVertexData.
| clearBounds ()
| Reverses the effect of a previous call to set_bounds(), and allows the bounding volume to be automatically computed once more based on the vertices.
| clearCache ()
| Removes all of the previously-cached results of munge_geom().
| clearCacheStage (Thread current_thread)
| Removes all of the previously-cached results of munge_geom(), at the current pipeline stage and upstream.
| clearPrimitives ()
| Removes all the primitives from the Geom object (but keeps the same table of vertices).
bool | copyPrimitivesFrom (Geom const other)
| Copies the primitives from the indicated Geom into this one.
Geom | decompose ()
| Decomposes all of the primitives within this Geom, returning the result.
| decomposeInPlace ()
| Decomposes all of the primitives within this Geom, leaving the results in place.
Geom | doubleside ()
| Doublesides all of the primitives within this Geom, returning the result.
| doublesideInPlace ()
| Doublesides all of the primitives within this Geom, leaving the results in place.
BoundingVolume const | getBounds (Thread current_thread)
| Returns the bounding volume for the Geom.
BoundingVolume const | getBounds ()
| Returns the bounding volume for the Geom.
BoundsType | getBoundsType ()
| Returns the bounding volume type set with set_bounds_type().
int | getGeomRendering ()
| Returns the set of GeomRendering bits that represent the rendering properties required to properly render this Geom.
UpdateSeq | getModified (Thread current_thread)
| Returns a sequence number which is guaranteed to change at least every time any of the primitives in the Geom is modified, or the set of primitives is modified.
UpdateSeq | getModified ()
| Returns a sequence number which is guaranteed to change at least every time any of the primitives in the Geom is modified, or the set of primitives is modified.
int | getNestedVertices (Thread current_thread)
| Returns the number of vertices rendered by all primitives within the Geom.
int | getNestedVertices ()
| Returns the number of vertices rendered by all primitives within the Geom.
int | getNumBytes ()
| Returns the number of bytes consumed by the geom and its primitives (but not including its vertex table).
int | getNumPrimitives ()
| Returns the number of GeomPrimitive objects stored within the Geom, each of which represents a number of primitives of a particular type.
GeomPrimitive const | getPrimitive (int i)
| Returns a const pointer to the ith GeomPrimitive object stored within the Geom.
list | getPrimitives ()
PrimitiveType | getPrimitiveType ()
| Returns the fundamental primitive type that is common to all GeomPrimitives added within the Geom.
ShadeModel | getShadeModel ()
| Returns the shade model common to all of the individual GeomPrimitives that have been added to the geom.
UsageHint | getUsageHint ()
| Returns the minimum (i.e.
GeomVertexData const | getVertexData (Thread current_thread)
| Returns a const pointer to the GeomVertexData, for application code to directly examine (but not modify) the geom's underlying data.
GeomVertexData const | getVertexData ()
| Returns a const pointer to the GeomVertexData, for application code to directly examine (but not modify) the geom's underlying data.
bool | isEmpty ()
| Returns true if there appear to be no vertices to be rendered by this Geom, false if has some actual data.
bool | isPrepared (PreparedGraphicsObjects prepared_objects)
| Returns true if the geom has already been prepared or enqueued for preparation on the indicated GSG, false otherwise.
Geom | makeCopy ()
| Returns a newly-allocated Geom that is a shallow copy of this one.
int | makeNonindexed (bool composite_only)
| Converts the geom from indexed to nonindexed by duplicating vertices as necessary.
Geom | makePoints ()
| Returns a new Geom with points at all the vertices.
| makePointsInPlace ()
| Replaces the GeomPrimitives within this Geom with corresponding GeomPoints.
| markBoundsStale ()
| Marks the bounding volume of the Geom as stale so that it should be recomputed.
GeomPrimitive | modifyPrimitive (int i)
| Returns a modifiable pointer to the ith GeomPrimitive object stored within the Geom, so application code can directly manipulate the properties of this primitive.
GeomVertexData | modifyVertexData ()
| Returns a modifiable pointer to the GeomVertexData, so that application code may directly maniuplate the geom's underlying data.
| offsetVertices (GeomVertexData const data, int offset)
| Replaces a Geom's vertex table with a new table, and simultaneously adds the indicated offset to all vertex references within the Geom's primitives.
| operator new (unsigned int size)
Geom | operator= (Geom const copy)
| The copy assignment operator is not pipeline-safe.
| output (ostream out)
| prepare (PreparedGraphicsObjects prepared_objects)
| Indicates that the geom should be enqueued to be prepared in the indicated prepared_objects at the beginning of the next frame.
GeomContext | prepareNow (PreparedGraphicsObjects prepared_objects, GraphicsStateGuardianBase gsg)
| Creates a context for the geom on the particular GSG, if it does not already exist.
bool | release (PreparedGraphicsObjects prepared_objects)
| Frees the geom context only on the indicated object, if it exists there.
int | releaseAll ()
| Frees the context allocated on all objects for which the geom has been declared.
| removePrimitive (int i)
| Removes the ith primitive from the list.
bool | requestResident ()
| Returns true if all the primitive arrays are currently resident in memory.
Geom | reverse ()
| Reverses all of the primitives within this Geom, returning the result.
| reverseInPlace ()
| Reverses all of the primitives within this Geom, leaving the results in place.
Geom | rotate ()
| Rotates all of the primitives within this Geom, returning the result.
| rotateInPlace ()
| Rotates all of the primitives within this Geom, leaving the results in place.
| setBounds (BoundingVolume const volume)
| Resets the bounding volume so that it is the indicated volume.
| setBoundsType (BoundsType bounds_type)
| Specifies the desired type of bounding volume that will be created for this Geom.
| setPrimitive (int i, GeomPrimitive const primitive)
| Replaces the ith GeomPrimitive object stored within the Geom with the new object.
| setUsageHint (UsageHint usage_hint)
| Changes the UsageHint hint for all of the primitives on this Geom to the same value.
| setVertexData (GeomVertexData const data)
| Replaces the Geom's underlying vertex data table with a completely new table.
| transformVertices (Mat4 const mat)
| Applies the indicated transform to all of the vertices in the Geom.
Geom | unify (int max_indices, bool preserve_order)
| Unifies all of the primitives contained within this Geom into a single (or as few as possible, within the constraints of max_indices) primitive objects.
| unifyInPlace (int max_indices, bool preserve_order)
| Unifies all of the primitives contained within this Geom into a single (or as few as possible, within the constraints of max_indices) primitive objects.
| write (ostream out, int indent_level)
| write (ostream out)
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

A container for geometry primitives.

This class associates one or more GeomPrimitive objects with a table of vertices defined by a GeomVertexData object. All of the primitives stored in a particular Geom are drawn from the same set of vertices (each primitive uses a subset of all of the vertices in the table), and all of them must be rendered at the same time, in the same graphics state.

## Constructor & Destructor Documentation

Geom | ( | GeomVertexData const | data | ) |

## Member Function Documentation

addPrimitive | ( | GeomPrimitive const | primitive | ) |

Adds a new GeomPrimitive structure to the Geom object.

This specifies a particular subset of vertices that are used to define geometric primitives of the indicated type.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

bool checkValid | ( |  | ) |

Verifies that the all of the primitives within the geom reference vertices that actually exist within the geom's GeomVertexData.

Returns true if the geom appears to be valid, false otherwise.

bool checkValid | ( | GeomVertexData const | vertex_data | ) |

Verifies that the all of the primitives within the geom reference vertices that actually exist within the indicated GeomVertexData.

Returns true if the geom appears to be valid, false otherwise.

clearBounds | ( |  | ) |

Reverses the effect of a previous call to set_bounds(), and allows the bounding volume to be automatically computed once more based on the vertices.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

clearCache | ( |  | ) |

Removes all of the previously-cached results of munge_geom().

This blows away the entire cache, upstream and downstream the pipeline. Use clear_cache_stage() instead if you only want to blow away the cache at the current stage and upstream.

clearCacheStage | ( | Thread | current_thread | ) |

Removes all of the previously-cached results of munge_geom(), at the current pipeline stage and upstream.

Does not affect the downstream cache.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

clearPrimitives | ( |  | ) |

Removes all the primitives from the Geom object (but keeps the same table of vertices).

You may then re-add primitives one at a time via calls to add_primitive().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

bool copyPrimitivesFrom | ( | Geom const | other | ) |

Copies the primitives from the indicated Geom into this one.

This does require that both Geoms contain the same fundamental type primitives, both have a compatible shade model, and both use the same GeomVertexData. Both Geoms must also be the same specific class type (i.e. if one is a GeomTextGlyph, they both must be.)

Returns true if the copy is successful, or false otherwise (because the Geoms were mismatched).

Geom decompose | ( |  | ) |

Decomposes all of the primitives within this Geom, returning the result.

See GeomPrimitive.decompose().

decomposeInPlace | ( |  | ) |

Decomposes all of the primitives within this Geom, leaving the results in place.

See GeomPrimitive.decompose().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

Geom doubleside | ( |  | ) |

Doublesides all of the primitives within this Geom, returning the result.

See GeomPrimitive.doubleside().

doublesideInPlace | ( |  | ) |

Doublesides all of the primitives within this Geom, leaving the results in place.

See GeomPrimitive.doubleside().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

BoundingVolume const getBounds | ( | Thread | current_thread | ) |

Returns the bounding volume for the Geom.

BoundingVolume const getBounds | ( |  | ) |

Returns the bounding volume for the Geom.

BoundsType getBoundsType | ( |  | ) |

Returns the bounding volume type set with set_bounds_type().

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from CopyOnWriteObject.

Reimplemented in GeomTextGlyph.

int getGeomRendering | ( |  | ) |

Returns the set of GeomRendering bits that represent the rendering properties required to properly render this Geom.

UpdateSeq getModified | ( | Thread | current_thread | ) |

Returns a sequence number which is guaranteed to change at least every time any of the primitives in the Geom is modified, or the set of primitives is modified.

However, this does not include modifications to the vertex data, which should be tested separately.

UpdateSeq getModified | ( |  | ) |

Returns a sequence number which is guaranteed to change at least every time any of the primitives in the Geom is modified, or the set of primitives is modified.

However, this does not include modifications to the vertex data, which should be tested separately.

int getNestedVertices | ( | Thread | current_thread | ) |

Returns the number of vertices rendered by all primitives within the Geom.

int getNestedVertices | ( |  | ) |

Returns the number of vertices rendered by all primitives within the Geom.

int getNumBytes | ( |  | ) |

Returns the number of bytes consumed by the geom and its primitives (but not including its vertex table).

int getNumPrimitives | ( |  | ) |

Returns the number of GeomPrimitive objects stored within the Geom, each of which represents a number of primitives of a particular type.

GeomPrimitive const getPrimitive | ( | int | i | ) |

Returns a const pointer to the ith GeomPrimitive object stored within the Geom.

Use this call only to inspect the ith object; use modify_primitive() or set_primitive() if you want to modify it.

list getPrimitives | ( |  | ) |

PrimitiveType getPrimitiveType | ( |  | ) |

Returns the fundamental primitive type that is common to all GeomPrimitives added within the Geom.

All nested primitives within a particular Geom must be the same type (that is, you can mix triangles and tristrips, because they are both the same fundamental type PT_polygons, but you cannot mix triangles and points withn the same Geom).

ShadeModel getShadeModel | ( |  | ) |

Returns the shade model common to all of the individual GeomPrimitives that have been added to the geom.

UsageHint getUsageHint | ( |  | ) |

Returns the minimum (i.e.

most dynamic) usage_hint among all of the individual GeomPrimitives that have been added to the geom.

GeomVertexData const getVertexData | ( | Thread | current_thread | ) |

Returns a const pointer to the GeomVertexData, for application code to directly examine (but not modify) the geom's underlying data.

GeomVertexData const getVertexData | ( |  | ) |

Returns a const pointer to the GeomVertexData, for application code to directly examine (but not modify) the geom's underlying data.

bool isEmpty | ( |  | ) |

Returns true if there appear to be no vertices to be rendered by this Geom, false if has some actual data.

bool isPrepared | ( | PreparedGraphicsObjects | prepared_objects | ) |

Returns true if the geom has already been prepared or enqueued for preparation on the indicated GSG, false otherwise.

Geom makeCopy | ( |  | ) |

Returns a newly-allocated Geom that is a shallow copy of this one.

It will be a different Geom pointer, but its internal data may or may not be shared with that of the original Geom.

int makeNonindexed | ( | bool | composite_only | ) |

Converts the geom from indexed to nonindexed by duplicating vertices as necessary.

If composite_only is true, then only composite primitives such as trifans and tristrips are converted. Returns the number of GeomPrimitive objects converted.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

Geom makePoints | ( |  | ) |

Returns a new Geom with points at all the vertices.

See GeomPrimitive.make_points().

makePointsInPlace | ( |  | ) |

Replaces the GeomPrimitives within this Geom with corresponding GeomPoints.

See GeomPrimitive.make_points().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

markBoundsStale | ( |  | ) |

Marks the bounding volume of the Geom as stale so that it should be recomputed.

Usually it is not necessary to call this explicitly.

GeomPrimitive modifyPrimitive | ( | int | i | ) |

Returns a modifiable pointer to the ith GeomPrimitive object stored within the Geom, so application code can directly manipulate the properties of this primitive.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

GeomVertexData modifyVertexData | ( |  | ) |

Returns a modifiable pointer to the GeomVertexData, so that application code may directly maniuplate the geom's underlying data.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

offsetVertices | ( | GeomVertexData const | data,
|  | int | offset
| ) |  |

Replaces a Geom's vertex table with a new table, and simultaneously adds the indicated offset to all vertex references within the Geom's primitives.

This is intended to be used to combine multiple GeomVertexDatas from different Geoms into a single big buffer, with each Geom referencing a subset of the vertices in the buffer.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

operator new | ( | unsigned int | size | ) |

Geom operator= | ( | Geom const | copy | ) |

The copy assignment operator is not pipeline-safe.

This will completely obliterate all stages of the pipeline, so don't do it for a Geom that is actively being used for rendering.

output | ( | ostream | out | ) |

prepare | ( | PreparedGraphicsObjects | prepared_objects | ) |

Indicates that the geom should be enqueued to be prepared in the indicated prepared_objects at the beginning of the next frame.

This will ensure the geom is already loaded into geom memory if it is expected to be rendered soon.

Use this function instead of prepare_now() to preload geoms from a user interface standpoint.

GeomContext prepareNow | ( | PreparedGraphicsObjects | prepared_objects,
|  | GraphicsStateGuardianBase | gsg
| ) |  |

Creates a context for the geom on the particular GSG, if it does not already exist.

Returns the new (or old) GeomContext. This assumes that the GraphicsStateGuardian is the currently active rendering context and that it is ready to accept new geoms. If this is not necessarily the case, you should use prepare() instead.

Normally, this is not called directly except by the GraphicsStateGuardian; a geom does not need to be explicitly prepared by the user before it may be rendered.

bool release | ( | PreparedGraphicsObjects | prepared_objects | ) |

Frees the geom context only on the indicated object, if it exists there.

Returns true if it was released, false if it had not been prepared.

int releaseAll | ( |  | ) |

Frees the context allocated on all objects for which the geom has been declared.

Returns the number of contexts which have been freed.

removePrimitive | ( | int | i | ) |

Removes the ith primitive from the list.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

bool requestResident | ( |  | ) |

Returns true if all the primitive arrays are currently resident in memory.

If this returns false, the data will be brought back into memory shortly; try again later.

This does not also test the Geom's associated GeomVertexData. That must be tested separately.

Geom reverse | ( |  | ) |

Reverses all of the primitives within this Geom, returning the result.

See GeomPrimitive.reverse().

reverseInPlace | ( |  | ) |

Reverses all of the primitives within this Geom, leaving the results in place.

See GeomPrimitive.reverse().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

Geom rotate | ( |  | ) |

Rotates all of the primitives within this Geom, returning the result.

See GeomPrimitive.rotate().

rotateInPlace | ( |  | ) |

Rotates all of the primitives within this Geom, leaving the results in place.

See GeomPrimitive.rotate().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setBounds | ( | BoundingVolume const | volume | ) |

Resets the bounding volume so that it is the indicated volume.

When it is explicitly set, the bounding volume will no longer be automatically computed; call clear_bounds() if you would like to return the bounding volume to its default behavior.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setBoundsType | ( | BoundsType | bounds_type | ) |

Specifies the desired type of bounding volume that will be created for this Geom.

This is normally BoundingVolume.BT_default, which means to set the type according to the config variable "bounds-type".

If this is BT_sphere or BT_box, a BoundingSphere or BoundingBox is explicitly created. If it is BT_best, a BoundingBox is created.

This affects the implicit bounding volume only. If an explicit bounding volume is set on the Geom with set_bounds(), that bounding volume type is used. (This is different behavior from the similar method on PandaNode.)

setPrimitive | ( | int | i,
|  | GeomPrimitive const | primitive
| ) |  |

Replaces the ith GeomPrimitive object stored within the Geom with the new object.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setUsageHint | ( | UsageHint | usage_hint | ) |

Changes the UsageHint hint for all of the primitives on this Geom to the same value.

See get_usage_hint().

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

setVertexData | ( | GeomVertexData const | data | ) |

Replaces the Geom's underlying vertex data table with a completely new table.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

transformVertices | ( | Mat4 const | mat | ) |

Applies the indicated transform to all of the vertices in the Geom.

If the Geom happens to share a vertex table with another Geom, this operation will duplicate the vertex table instead of breaking the other Geom; however, if multiple Geoms with shared tables are transformed by the same matrix, they will no longer share tables after the operation. Consider using the GeomTransformer if you will be applying the same transform to multiple Geoms.

Geom unify | ( | int | max_indices,
|  | bool | preserve_order
| ) |  |

Unifies all of the primitives contained within this Geom into a single (or as few as possible, within the constraints of max_indices) primitive objects.

This may require decomposing the primitives if, for instance, the Geom contains both triangle strips and triangle fans.

max_indices represents the maximum number of indices that will be put in any one GeomPrimitive. If preserve_order is true, then the primitives will not be reordered during the operation, even if this results in a suboptimal result.

unifyInPlace | ( | int | max_indices,
|  | bool | preserve_order
| ) |  |

Unifies all of the primitives contained within this Geom into a single (or as few as possible, within the constraints of max_indices) primitive objects.

This may require decomposing the primitives if, for instance, the Geom contains both triangle strips and triangle fans.

max_indices represents the maximum number of indices that will be put in any one GeomPrimitive. If preserve_order is true, then the primitives will not be reordered during the operation, even if this results in a suboptimal result.

Don't call this in a downstream thread unless you don't mind it blowing away other changes you might have recently made in an upstream thread.

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

write | ( | ostream | out | ) |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties